;;; - ------------------------------------------------------------------------------ - ;
;;; - Funktionsname : block-import                                                   - ;
;;; - Beschreibung  : Kommandozeilenversion : Importieren von Blockdefinitionen einer- ;
;;;                   DWG-Datei, wenn diese in der aktuell geffneten Zeichnung noch - :
;;;                   nichg vorhanden sind                                           - ;
;;; - Parameter     : "liste": Liste mit Blockname, die Importiert werden sollen     - ;
;;;                 : "dwgname": Pfad+Dateiname der DWG-Datei                        - ;
;;; - Rckgabe      : keine                                                          - ;
;;; - ------------------------------------------------------------------------------ - ;

;;;Originalfunktion "c: BKS-IMPORT" von (C) Thomas Krger 2005 (cadmium@cad.de)
;;;http://autocad.cad.de/modules.php?name=News&file=article&sid=20

;;;gendert in "block-import" Jrn Bosse, 22.11.05

(defun block-import(liste dwgname /  blocks ARRAY DBX ITEM A temp)
;;;  (setq liste '("BATPKT" "BATPHO"))
  (if(and 
         (or(not(vl-catch-all-error-p         ;_ versuchen ObjectXserver zu installieren
                  (setq DBX (vl-catch-all-apply                 ;_ dabei Fehler abfangen
                               'vla-GetInterfaceObject
                               (list
                                 (vlax-get-acad-object)
                                 "ObjectDBX.AxDbDocument.16"     ;_ versionsabhngig !!!
                               )                                    ;_ACAD2004 und hher
                            )
                 )
               )
            )
            (not(vl-catch-all-error-p ;_ oder der 
                  (setq DBX (vl-catch-all-apply
                               'vla-GetInterfaceObject
                               (list
                                 (vlax-get-acad-object)
                                 "ObjectDBX.AxDbDocument.15"                  ;_ACAD2002
                               )
                            )
                 )
               )
            )
            (not(vl-catch-all-error-p
                  (setq DBX (vl-catch-all-apply
                               'vla-GetInterfaceObject
                               (list
                                 (vlax-get-acad-object)
                                 "ObjectDBX.AxDbDocument"                     ;_ACAD2000
                               )
                            )
                 )
               )
            )
            (progn                                  ;_ Fehlerausgabe und Programmabbruch
              (if (=(getvar"CMDECHO")1)(princ "
ObjectDBX-Server nicht gefunden"))
              (princ)
            )
         )
         (or(not(vl-catch-all-error-p                ;_ Versuchen DWG als DBX zu  ffnen
                  (vl-catch-all-apply                           ;_ dabei Fehler abfangen
                    'vla-open
                    (list DBX DWGNAME))                  
                )
            )    
            (progn              ;_ Fehlerausgabe , wenn Datei nicht geffnet werden kann
              (if (=(getvar"CMDECHO")1)(princ "
Datei nicht gefunden."))
              (princ)
            )
         )
         (not(vl-catch-all-error-p ;Block_Collection
               (setq blocks(vla-get-blocks DBX))      
             )
         )
     )    
    (progn
      (setq i -1)
      (vlax-for ITEM blocks                   ;wenn Blockname aus Block_Collection in Liste, dann in temp-Liste 
	(if (and(member(vla-get-name ITEM)liste)
		(not (tblsearch "BLOCK" (vla-get-name ITEM))))
	  (setq temp (cons ITEM temp)))
	  (setq i(1+ i)))
      (if temp
	(progn
      (setq ARRAY(vl-catch-all-apply          
                            'vlax-make-safearray
                            (list
                              vlax-vbObject                          
                             (cons 0 (1- (length temp)))
                            )
                          )
               )
	
      (setq i -1)
      (mapcar '(lambda(A)
		 (vlax-safearray-put-element ARRAY (setq i(1+ i)) A))temp); Blcke ARRAY zuweisen
	  
                                                                  
      (not(vl-catch-all-error-p
            (vl-catch-all-apply
              'vla-CopyObjects            ;_ die Blockdefinitionen in die Zeichnung kopieren
              (list                                       ;_dabei evtl. Fehler abfangen
                DBX
                ARRAY
                (vla-get-Blocks(vla-get-activedocument(vlax-get-acad-object)))
             ) 
           )
          )
      )
      (princ "\nEs wurden folgenden Blockdefinitionen in die Zeichnung eingefgt:")
      (mapcar '(lambda(A)
		 (princ (strcat"\n"(vla-get-name A))))(reverse temp)))
	(princ "\nEs wurden keine Blockdefinitionen eingefgt."))
                                                    
      (not(vl-catch-all-error-p                 
            (vl-catch-all-apply          
             'vlax-release-object(list DBX)          ;_DBX-Verknfung wieder freigeben
            )
          )
      )      
       
        
    )  
  )
  (princ)
)
